# 氦氪HEKR模块串口透传协议参考实现

本项目为[氦氪HEKR模块串口透传协议](http://docs.hekr.me/v4/%E7%A1%AC%E4%BB%B6%E5%BC%80%E5%8F%91/%E9%80%9A%E4%BF%A1%E5%8D%8F%E8%AE%AE/%E4%B8%B2%E5%8F%A3%E9%80%8F%E4%BC%A0%E5%8D%8F%E8%AE%AE/)
和[48透传协议/2G模块协议](http://docs.hekr.me/v4/%E7%A1%AC%E4%BB%B6%E5%BC%80%E5%8F%91/%E9%80%9A%E4%BF%A1%E5%8D%8F%E8%AE%AE/48%E9%80%8F%E4%BC%A0%E5%8D%8F%E8%AE%AE/)的参考实现，用于演示使用48协议直接接入HEKR云的设备的具体消息交互流程。

## 软件需求

1. 主流发行版的GNU/Linux操作系统
2. GNU Make
3. GCC/Clang

## 源码结构

- `ra_types.h`：基本类型定义
- `hekr48trans.c`、 `hekr48trans.h`：与云端交互的消息构造接口。
- `md5sum.c`、`md5sum.h`：构建消息时使用的**MD5**实现

实际项目的开发过程中只需要用到以上几个文件对交互使用的消息进行构造。

- `main.c`：演示程序入口
- `Makefile`：构建文件
- `README.md`：本说明文件
- `usocket.c`、`usocket.h`：演示程序使用的Socket封装。

以上文件只是给出一个使用消息构建接口的简单说明，实际项目中可以参考。


## 构建

克隆源码或者下载源码：

```bash
git clone http://gitlab.hekr.me/open-source/demo-48-clang.git
cd demo-48-clang
```

编译：

```bash
make
```

## 使用

在HEKR云的[console(https://console.hekr.me/)平台创建48透传协议的产品，批量生成设备后，填入一组*prodkey*、*devtid*、*devprikey*，观察消息收发过程。

```bash
./a.out <prodkey> <devtid> <devprikey>